#ifndef __PAINT_HPP__
#define __PAINT_HPP__

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/

/******************************************************************************
    Purpose:
    To provide common drawing operations on CSurfaceS

    !! note: untested what happens when an object of type CPaint
			 is copied. Should theoretically be no problem, but
			 I'm not quite sure how DirectDraw behaves when you
			 try to lock/unlock surfaces multiple times

	Possible design alternatives:
	Don't make these drawing operations a class, after all they don't have
	much in common besides working on surfaces which can be passed in as
	parameters
******************************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

#pragma warning ( disable : 4786 )
#pragma warning ( push, 1 )
#include <string>
#pragma warning ( pop )

class CSurface;

class
CPaint
{
public:
    CPaint( void );

    CSurface *SetDrawingTarget( CSurface *Dest );
    void BeginDrawing( void );
    void EndDrawing( void );

    void PutPixel( tSINT32 X, tSINT32 Y, tUINT16 Color );
	void DrawRect( tSINT32 X1, tSINT32 Y1, tSINT32 X2, tSINT32 Y2, tUINT16 Color );

    void Fill( tUINT16 Color );
	void Fill( tSINT32 x1, tSINT32 y1, tSINT32 x2, tSINT32 y2, tUINT16 Color );
    void LoadBmp( const std::string & FileName );
    bool GetBmpDimensions( 
		const char *FileName,
		tSINT32 *Width,
		tSINT32 *Height );

private:
    CSurface *	m_Destination;
    tUINT16	*	m_SurfaceMem;
    tSINT32		m_Pitch;
};

#endif
