#ifndef __PIXELCONVERTER_HPP__
#define __PIXELCONVERTER_HPP__

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/

/******************************************************************************
    Purpose:
    To convert color values from 24bit 888RGB to 16bit XXXxxx. The target
    format is extracted from a valid surface (the primary surface for example).
******************************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

class CSurface;

class
CPixelConverter
{
public:
    CPixelConverter( CSurface *Surface );

    tUINT16 RGBToColor( tUINT8 Red, tUINT8 Green, tUINT8 Blue );

private:
    tUINT16 RBitCount, GBitCount, BBitCount;
    tUINT16 RBitPos, GBitPos, BBitPos;

    void ProcessBits( tUINT32 Mask, tUINT16 *LowBit, tUINT16 *NumBits );
};

#endif
