#include "time.hpp"

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/


#pragma warning ( push, 1 )
#ifndef __WINDOWS_H__
#define __WINDOWS_H__
  #ifndef WIN32_LEAN_AND_MEAN
  #define WIN32_LEAN_AND_MEAN
  #endif
#include <windows.h>
#endif
#pragma warning ( pop )

#include "general\debug.hpp"
#include "general\helpmacros.hpp"

CTimer Timer;

/*
 *
 */
CTimer::CTimer( void )
	: Frequency( 0 )
{
	LARGE_INTEGER Temp;
    bool ReturnValue = false;
	ReturnValue = ( QueryPerformanceFrequency( &Temp ) != 0 );
	ASSERT( ReturnValue );
	Frequency = Temp.QuadPart;
}

/*
 * returns the number of ticks since windows start (?)
 * !! the conversion to double loses some precision, but the time to
 *    overflow should still be sufficient
 */
tSINT64
CTimer::GetTime( void )
{
	LARGE_INTEGER Temp;
    bool ReturnValue = ( QueryPerformanceCounter( &Temp ) != 0 );
	ASSERT( ReturnValue );

    return Temp.QuadPart;
}

