#ifndef __MINIMAP_HPP__
#define __MINIMAP_HPP__

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/

/*********************************************************************
		Minimap.hpp

		History of Changes:
		- 29.09.2000 file created by Capella
**********************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif


//#define MM_SIZE_X	100
//#define MM_SIZE_Y	100

class CMap;
class CSurface;


class cMINIMAP
{
private:
    CSurface* Surface;
	const tSINT32 MM_SIZE_X, MM_SIZE_Y;

	// copy and assignement forbidden
	cMINIMAP( const cMINIMAP& )
		: MM_SIZE_X( 0 ), MM_SIZE_Y( 0 ) {};
	cMINIMAP &operator = ( const cMINIMAP& ) {return *this;};

public:
	cMINIMAP();
	~cMINIMAP();
    void Refresh(CMap* NewMap);
    void RefreshPixel(CMap* Map, tSINT32 PosX, tSINT32 PosY);
    void Blit(CSurface* Dest, tSINT32 XKoord, tSINT32 YKoord);
};

#endif
