#ifndef __DEBUG_HPP__
#define __DEBUG_HPP__
#include "General/Configuration.hpp"

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/


#pragma warning ( push, 1 )
#include <fstream>
#pragma warning ( pop )

void FileAssert( bool Expression, const char *ErrorFileName, unsigned int ErrorLineNr );
void InitLogging( const char *LogFileName );
void ShutDownLogging( void );
extern std::ofstream *LOG;

#ifdef _DEBUG
#define ASSERT( BooleanExpression ) { FileAssert( BooleanExpression, __FILE__, __LINE__ ); }
#else
#define ASSERT( BooleanExpression )
#endif

#ifdef _DEBUG
#define DEBUGCODE( CodeFragment ) CodeFragment
#else
#define DEBUGCODE( CodeFragment )
#endif

#endif
