#ifndef __HELPMACROS_HPP__
#define __HELPMACROS_HPP__

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/

/******************************************************************************
    Purpose:
    Sammlung von Allzweckmacros, die immer und berall handy sind

    History of Changes:
    - 06.02.1999: file created by BuschnicK
    - 27.02.1999: renamed DELETE to SAFEDELETE because DELETE was
                  already defined somewhere in the win***.h files...
    - 14.03.1999: !!! should check 'release()' return value, cause it might not be safe
		  to set the pointer to NULL - there might still be references to that
 		  object left
*****************************************************************************/

#include "general\type.hpp"
#include "general\debug.hpp"

#define RELEASE( PointerVariable )          \
{                                           \
    ASSERT( PointerVariable != NULL );      \
    PointerVariable->Release();      \
    PointerVariable = NULL;                 \
} // !!! PointerVariable = NULL?! Nach Release() knnen eventuell immer noch references auf objekt vorhanden sein
  // !!! ASSERT() PointerVariable != NULL; doesn't seem to trigger

#define SAFEDELETE( PointerVariable )       \
{											\
    delete PointerVariable;					\
    PointerVariable = NULL;					\
}

#define SAFEDELETEARRAY( PointerVariable )	\
{											\
    delete [] PointerVariable;				\
    PointerVariable = NULL;					\
}

#define QUIT exit( EXIT_FAILURE );

#endif
