#include "general/Observer.hpp"

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/


#pragma warning ( push, 1 )
#include <cassert>
#pragma warning ( pop )


#include "general/debug.hpp"


CBroadcaster::CBroadcaster()
	: m_Listeners()
{
}


void
CBroadcaster::Attach( CListener *Listener )
{
	assert( Listener != NULL );
	m_Listeners.push_back( Listener );
	// !! should I assert unique Observers here?
}


void
CBroadcaster::Detach( CListener *Listener )
{
	assert( Listener != NULL );
	m_Listeners.remove( Listener );
}


void
CBroadcaster::Notify( void )
{
    for ( std::list< CListener * >::iterator i = m_Listeners.begin( ); 
		i != m_Listeners.end( ); ++i )
	{
		(*i)->Update( this );
	}
}

