#ifndef __OBSERVER_HPP__
#define __OBSERVER_HPP__

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/

/******************************************************************************
******************************************************************************/

#pragma warning ( disable: 4514 )
#pragma warning ( push, 1 )
#include <list>
#pragma warning ( pop )

class CBroadcaster;


class CListener
{
public:
    virtual ~CListener( ) = 0 {};

    virtual void Update( CBroadcaster *Subject ) = 0;

protected:
	// prevent observer objects form being created directly, only to be used as abstract base
    CListener( ) {};
};


class CBroadcaster
{
public:
    virtual ~CBroadcaster( ) = 0 {};

    virtual void Attach( CListener *Listener );
    virtual void Detach( CListener *Listener );
	virtual void Notify( void );

protected:
	// prevent subject objects form being created directly, only to be used as abstract base
    CBroadcaster( );

private:
    std::list< CListener * > m_Listeners;
};


#endif
