#ifndef __VECTOR_HPP__
#define __VECTOR_HPP__

/******************************************************************************
 * BlackFish
 * Copyright (C) 1999-2001 Sren Meyer-Eppler, Jutta Jordans
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ******************************************************************************/


#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

class
CMatrix3x3
{
public:

	tFLOAT x1, y1, z1,
		   x2, y2, z2,
		   x3, y3, z3;

public:

    CMatrix3x3( void );
    CMatrix3x3( tFLOAT x1, tFLOAT y1, tFLOAT z1,
				tFLOAT x2, tFLOAT y2, tFLOAT z2,
				tFLOAT x3, tFLOAT y3, tFLOAT z3 );

	void Set( tFLOAT x1, tFLOAT y1, tFLOAT z1,
			  tFLOAT x2, tFLOAT y2, tFLOAT z2,
			  tFLOAT x3, tFLOAT y3, tFLOAT z3 );
};

class
CVector
{
public:

	tFLOAT x, y, z;

public:

    CVector( void );
    CVector( tFLOAT x, tFLOAT y, tFLOAT z );

	void Set( tFLOAT x, tFLOAT y, tFLOAT z );
    void Set( CVector Vector );
    void Multiply( CMatrix3x3 *Matrix, CVector *Vector );
	void Multiply( tFLOAT Skalar );
    void Add( CVector Vector );
    void Subtract( CVector Vector );
	void Normalize( void );
    bool Equals( CVector Vector );
	tFLOAT GetLength( void );
};

#endif
